{$R-}
Program War_Ocean;
Uses Graph,Dos,New_Crt;
Const MaxX = 'j';
      MaxY = 10;
      MaxShip = 24;
      NButton:Byte = 0;
      MousePresent:boolean = false;
      MouseVisible: boolean = false;
Type
      CrdX = #96..MaxX;
      CrdY = 0..MaxY;

      Korable=0..4;
      Pole = record
             Ship:boolean;
             Crash:boolean;
             Damage:(No,Kill,Wounded);
             TypeShip:Korable;
             Coordinate : array [1..4] of record
                                KorX:CrdX;
                                KorY:CrdY
                          end;
      end;
      Map = array ['a'..MaxX,1..MaxY] of Pole;
      {$F+}
      {$R+}
      TypeShipFor = Array[1..4] of Korable;

      ProcCoord = procedure(Var x:CrdX; Var y:CrdY);
      Coord = record
                    x:CrdX;
                    y:CrdY
              end;
     TypeArray = array [1..MaxShip] of Coord;
Const
      PalubForComputer: TypeShipFor= (1,2,3,4);
      PalubForGamer:    TypeShipFor= (1,2,3,4);
      ShipForComputer:TypeShipFor = (4,3,2,2);
      ShipForGamer:   TypeShipFor = (4,3,2,2);

Var ComputerMap,GamerMap:Map;
    Conqueror: (UnKnown,Computer,Gamer);
    Gd,Gm:integer;
    Exit1:boolean;
    reg:registers;
    Ranen,PRanen,PPRanen: Coord;

Function IsMouse:boolean;
         Var p:pointer;
             k,x,y: integer;
             Is:boolean;
         Begin
              if NButton=0 then
                 begin
                      GetIntVec ($33,p);
                      Is:=p<>nil;
                      if is then with reg do
                         begin
                              ax:=$3;
                              bx:=$FFFF;
                              Intr($33,reg);
                              is:= bx<>$FFFF
                         end;
                      MousePresent:=is;
                 end;
              IsMouse:=MousePresent
         end;
Procedure ShowMouse;
Begin
     if IsMouse and not MouseVisible then
        With Reg do begin
             ax:=$1;
             intr ($33,reg);
             MouseVisible:=True
        end
end;
Procedure HideMouse;
Begin
     if IsMouse and MouseVisible then with reg do
        begin
             ax:=$2;
             Intr($33,reg);
             MouseVisible:=false;
        end;
end;
Function MouseIn (x1,y1,x2,y2:integer):boolean;
Begin
     if IsMouse then with Reg do
        Begin
             ax:=$3;
             Intr($33,Reg);
             MouseIn:= (cx>=x1) and(cx<=x2) and (dx>=y1) and (dx<=y2);
        end
     else
         MouseIn:=false;
end;
Procedure MouseButtPressed (Butt:integer; Var Stat, Count,X,Y:integer);
begin
     if IsMouse then with Reg do begin
        ax:= $5;
        bx:= Butt;
        Intr($33,reg);
        Count:=bx;
        x:=cx;
        y:=dx;
        stat:=bx;
     end;
end;
Procedure Sleep;
          var   a:char;
          Begin
               Repeat Until KeyPressed;
               a:=readkey;
          end;
Procedure InterfaceGame (Ramka,Map,Ship,Crash,TypeShip:boolean);
          Var i,j,x,y,x1,y1:integer;
              st:string;
          Begin
               HideMouse;
               If Ramka then Begin
                  SetColor(9);
                  SetFillStyle(6,1);
                  Bar(0,0,30,GetMaxY);
                  Bar(0,0,GetMaxX,30);
                  Bar(GetMaxX,0,GetMaxX-30,GetMaxY);
                  Bar(GetMaxX,GetMaxY,0,GetMaxY-30);
                  Rectangle(0,0,30,GetMaxY);
                  Rectangle(0,0,GetMaxX,30);
                  Rectangle(GetMaxX,0,GetMaxX-30,GetMaxY);
                  Rectangle(GetMaxX,GetMaxY,0,GetMaxY-30);
               end;
               If map then Begin
                  SetFillStyle(1,1);
                  Bar(50,50,GetMaxX div 2 ,GetMaxX div 2);
                  Bar(GetMaxX-50,50,GetMaxX div 2 ,GetMaxX div 2);
                  Rectangle(50,50,GetMaxX div 2 ,GetMaxX div 2);
                  Rectangle(GetMaxX-50,50,GetMaxX div 2 ,GetMaxX div 2);
                  x:=50; y:=50;x1:=0; y1:=0;
                  For i:= 1 to 10 do
                      Begin
                           x1:=x; y:=50; y1:=0;
                           x:=x+(((GetMaxX div 2)-50) div (ord(MaxX)-96)+1);
                           OutTextXY(x-15,40,chr(i+96));
                           OutTextXY(x-15+(((GetMaxX div 2)-50) div (ord(MaxX)-96)+1)*(ord(MaxX)-96),40,chr(i+96));
                           OutTextXY(x-15,55+(((GetMaxX div 2)-50) div (ord(MaxX)-96)+1)*(ord(MaxX)-96),chr(i+96));
                           OutTextXY(x-15+(((GetMaxX div 2)-50) div (ord(MaxX)-96)+1)*(ord(MaxX)-96),55+(((GetMaxX div 2)-50)
                           div (ord(MaxX)-96)+1)*(ord(MaxX)-96),chr(i+96));

                           if i<>10 then begin
                              OutTextXY(35,x-15,chr(i+48));
                              OutTextXY(GetMaxX-48,x-15,chr(i+48));
                           end;
                           For j:= 1 to 10 do
                               Begin
                                    y1:=y;
                                    y:=y+((GetMaxX div 2)-50) div MaxY+1;
                                    Rectangle(GetMaxX-x,y,GetMaxX-x1,y1);
                                    Rectangle(x,y,x1,y1);
                               end;
                      end;
                  OutTextXY(35,x-15,chr(49)+chr(48));
                  OutTextXY(GetMaxX-48,x-15,chr(49)+chr(48));
               end;
               If TypeShip then begin
                  SetColor(9);
                  x:=50; y:=(GetMaxY div 2) + 96;
                  For i:= 1 to 4 do begin
                      if i<=1 then begin
                              Rectangle(x+28*(i-1),y,x+28*i,y+28);
                              Rectangle(GetMaxX-(x+28*(i-1)),y,GetMaxX-(x+28*i),y+28);
                              SetColor(0);
                              OutTextXY(x+28*5,y+12,'');
                              OutTextXY(GetMaxX-(x+28*5),y+12,'');
                              SetColor(9);
                              Str(ShipForGamer[1],st);
                              OutTextXY(x+28*5,y+12,st);
                              Str(ShipForComputer[1],st);
                              OutTextXY(GetMaxX-(x+28*5),y+12,st);
                      end;
                      if i<=2 then begin
                              Rectangle(x+28*(i-1),y+28,x+28*i,y+28+28);
                              Rectangle(GetMaxX-(x+28*(i-1)),y+28,GetMaxX-(x+28*i),y+28+28);
                              SetColor(0);
                              OutTextXY(x+28*5,y+28+12,'');
                              OutTextXY(GetMaxX-(x+28*5),y+28+12,'');
                              SetColor(9);
                              Str(ShipForGamer[2],st);
                              OutTextXY(x+28*(5),y+28+12,st);
                              Str(ShipForComputer[2],st);
                              OutTextXY(GetMaxX-(x+28*(5)),y+28+12,st);
                      end;
                      if i<=3 then begin
                              Rectangle(x+28*(i-1),y+28+28,x+28*i,y+28+28+28);
                              Rectangle(GetMaxX-(x+28*(i-1)),y+28+28,GetMaxX-(x+28*i),y+28+28+28);
                              SetColor(0);
                              OutTextXY(x+28*(5),y+28+28+12,'');
                              OutTextXY(GetMaxX-(x+28*(5)),y+28+28+12,'');
                              SetColor(9);
                              Str(ShipForGamer[3],st);
                              OutTextXY(x+28*(5),y+28+28+12,st);
                              Str(ShipForComputer[3],st);
                              OutTextXY(GetMaxX-(x+28*(5)),y+28+28+12,st);
                      end;
                      if i<=4 then begin
                              Rectangle(x+28*(i-1),y+28+28+28,x+28*i,y+28+28+28+28);
                              Rectangle(GetMaxX-(x+28*(i-1)),y+28+28+28,GetMaxX-(x+28*i),y+28+28+28+28);
                              SetColor(0);
                              OutTextXY(x+28*(5),y+28+28+28+12,'');
                              OutTextXY(GetMaxX-(x+28*(5)),y+28+28+28+12,'');
                              SetColor(9);
                              Str(ShipForGamer[4],st);
                              OutTextXY(x+28*(5),y+28+28+28+12,st);
                              Str(ShipForComputer[4],st);
                              OutTextXY(GetMaxX-(x+28*(5)),y+28+28+28+12,st);
                      end;
                  end;
               end;
               If Crash then begin
                  SetFillStyle(1,5);
                  SetColor(15);
                  x:=50;
                  y:=50;
                  For i:= 1 to 10 do begin
                      x1:=x+27;
                      y:=50;
                      For j:= 1 to 10 do begin
                          y1:=y+27;
                          if GamerMap[chr((x div 28)+96),(y div 28)].Crash then begin
                             Bar(x,y,x1,y1);
                          end;
                          if ComputerMap[chr((x div 28)+96),(y div 28)].Crash then begin
                             Bar((GetMaxX div 2)+x-50,y,(GetMaxX div 2)+x1-50,y1);
                          end;
                          Inc(y,(((GetMaxX div 2)-50) div MaxY+1));
                      end;
                      Inc(x,(((GetMaxX div 2)-50) div (ord(MaxX)-96)+1));
                  end;
                  SetFillStyle(1,4);
                  x:=50;
                  y:=50;
                  For i:= 1 to 10 do begin
                      x1:=x+27;
                      y:=50;
                      For j:= 1 to 10 do begin
                          y1:=y+27;
                          if GamerMap[chr((x div 28)+96),(y div 28)].Crash and
                             GamerMap[chr((x div 28)+96),(y div 28)].ship then begin
                             Bar(x,y,x1,y1);
                             Rectangle(x,y,x1,y1);

                          end;
                          if ComputerMap[chr((x div 28)+96),(y div 28)].Crash and
                             ComputerMap[chr((x div 28)+96),(y div 28)].ship then begin
                             Bar((GetMaxX div 2)+x-50,y,(GetMaxX div 2)+x1-50,y1);
                             Rectangle((GetMaxX div 2)+x-50,y,(GetMaxX div 2)+x1-50,y1);
                          end;
                          Inc(y,(((GetMaxX div 2)-50) div MaxY+1));
                      end;
                      Inc(x,(((GetMaxX div 2)-50) div (ord(MaxX)-96)+1));
                  end;
               end;
               if Ship then begin
                  SetFillStyle(1,9);
                  x:=50;
                  y:=50;
                  For i:= 1 to 10 do begin
                      x1:=x+27;
                      y:=50;
                      For j:= 1 to 10 do begin
                          y1:=y+27;
                          if GamerMap[chr(i+96),j].ship then begin
                             Bar(x,y,x1,y1);
                          end;
                          Inc(y,(((GetMaxX div 2)-50) div MaxY+1));
                      end;
                      Inc(x,(((GetMaxX div 2)-50) div (ord(MaxX)-96)+1));
                  end;
               end;
               SetColor(15);
               Rectangle(50,50,GetMaxX div 2 ,GetMaxX div 2);
               Rectangle(GetMaxX-50,50,GetMaxX div 2 ,GetMaxX div 2);
               SetColor(9);
          end;
Procedure RNDComputer(var x:CrdX;var y:CrdY);
          Function RNDx:CrdX;
                   var a:integer;
                   Begin
                       a:=random(ord(MaxX)-96)+97;
                       RNDx:=chr(a);
                   end;
          Function RNDy: CrdY;
                   Begin
                        RNDy:=random(MaxY)+1;
                   end;
          Begin
               InterfaceGame(False,False,False,False,True);
               randomize;
               x:=RNDx;
               y:=RNDy;
          End;
Procedure RNDGamer(Var x:CrdX; Var y:CrdY);
          Var Stat,Count,x2,y2:integer;
          Begin
               InterfaceGame(False,False,True,False,True);
               ShowMouse;
               Repeat MouseButtPressed(0,Stat,Count,x2,y2);
                      If KeyPressed then
                         if ReadKey=#27 then begin
                            Exit1:=True;
                            Exit;
                         end;
                      Until (Stat=1) and
                            (MouseIn(50,50,GetMaxX div 2 ,GetMaxX div 2));
               x:=chr((x2 div 27)+95);
               y:=(y2 div 27)-1;
               HideMouse;
          end;

Procedure ZapolnMap(var rMap:Map; Proc:ProcCoord; var ShipKol:TypeShipFor);
          Var
              x,x2:CrdX;
              y,y2:CrdY;
              Scaner,i:integer;
              Soseds: TypeArray;
          Procedure SoedSosed;
                    Var i,j,k:integer;
                    Begin
                         j:=1;
                         k:=0;
                         While j<=Scaner do begin
                               Inc(ShipKol[rMap[Soseds[j].x,Soseds[j].y].TypeShip]);
                               j:=j+rMap[Soseds[j].x,Soseds[j].y].TypeShip;
                         end;

                         For i:= 1 to Scaner do begin
                             rMap[x,y].Coordinate[i].KorX:=Soseds[i].X;
                             rMap[x,y].Coordinate[i].KorY:=Soseds[i].Y;
                             rMap[Soseds[i].x,Soseds[i].y].TypeShip:=Scaner+1;
                         End;
                         rMap[x,y].Coordinate[Scaner+1].KorX:=x;
                         rMap[x,y].Coordinate[Scaner+1].KorY:=Y;
                         rMap[x,y].TypeShip:=Scaner+1;
                         For i:= 1 to Scaner do begin
                             with rMap[x,y].Coordinate[i] do begin
                                  for j:= 1 to Scaner+1 do begin
                                      rMap[KorX,KorY].Coordinate:=rMap[x,y].Coordinate;
                                  end;
                             end;
                         end;
                    end;

          Function ScanSosed (x:CrdX; y:CrdY):integer;
                   var n:integer;
                   Procedure Soed(x:CrdX; y:CrdY);
                             Var i:integer;
                             Begin
                                  If rMap[x,y].Ship then begin
                                     For i:= n+1 to n+rMap[x,y].TypeShip do begin
                                         Soseds[i].X:=rMap[x,y].Coordinate[i-n].KorX;
                                         Soseds[i].Y:=rMap[x,y].Coordinate[i-n].KorY;
                                     end;
                                     n:=n+rMap[x,y].TypeShip;
                                  end;
                             end;
                   Procedure Lish;
                             Var i,k:integer;
                                 S: TypeArray;
                             Function Prenad(n,k:integer):boolean;
                                      Var i:integer;
                                          p:boolean;
                                      Begin
                                           p:=false;
                                           For i:= 1 to k do
                                               if  (S[i].x=Soseds[n].x) and (s[i].y=Soseds[n].y) then p:=true;
                                           Prenad:=p;
                                      end;
                             Begin
                                  For i:= 1 to MaxShip do begin
                                          s[i].x:=pred('a');
                                          s[i].y:=0;
                                  end;
                                  k:=0;
                                  For i:= 1 to n do begin
                                      if not Prenad(i,k) then Begin
                                         inc(k);
                                         s[k]:=Soseds[i];
                                      end;
                                  end;
                                  Soseds:=s;
                                  n:=k;
                             End;
                   Begin
                        n:=0;
                        if x<>'a' then Soed(Pred(x),y);
                        If x<>MaxX then Soed(Succ(x),y);
                        If y<>1 then Soed(x,Pred(y));
                        if y<>MaxY then Soed(x,Succ(y));
                        Lish;
                        ScanSosed:=n;
                   End;
          Function Param:boolean;
             Var Param1,
                 Param2,
                 Param3,
                 Param4,
                 Param5,
                 Param6:boolean;
                 x2:CrdX;
                 y2:CrdY;
             Begin
                 Scaner:=0;
                 Param1:= not rMap[x,y].ship;
                 Param2:=false;
                 if Param1 then begin
                    Scaner:=ScanSosed(x,y);
                    If Scaner<4 then
                       Param2:= (ShipKol[Scaner+1]>0);
                 end;

                 Param:= Param1 and Param2;
             end;
          Begin
               if exit1 then exit;
               For x:='a' to MaxX do
                   For y:= 1 to MaxY do
                       with rMap[x,y] do begin
                            Ship:=false;
                            Crash:=false;
                            Damage:=No;
                             For i:= 1 to 4 do begin
                                 Coordinate[i].KorX:=pred('a');
                                 Coordinate[i].KorY:=0;
                             end;
                       end;

               While (ShipKol[1]<>0) or (ShipKol[2]<>0) or
                     (ShipKol[3]<>0) or (ShipKol[4]<>0) do begin
                     Repeat Proc(x,y);
                           if KeyPressed then
                              If ReadKey=#27 then exit1:=true;
                           if exit1 then exit;
                     Until Param;
                     rMap[x,y].Ship:=True;
                     SoedSosed;
                     Dec(ShipKol[rMap[x,y].TypeShip]);
               end;
          end;
Function HowManyGamersShips:integer;
         Var n:integer;
             i:CrdX; J:CrdY;
         Begin
              n:=MaxShip;
              For i:= 'a' to MaxX do begin
                  For j:= 1 to MaxY do
                      if GamerMap[i,j].damage <> No then Dec(n,1);
              end;
              HowManyGamersShips:=n;
         end;
Function HowManyComputersShips:integer;
         Var n:integer;
             i:CrdX; J:CrdY;
         Begin
              n:=MaxShip;
              For i:= 'a' to MaxX do begin
                  For j:= 1 to MaxY do
                      if ComputerMap[i,j].damage <> No then Dec(n,1);
              end;
              HowManyComputersShips:=n;
         end;

Procedure Schet;
          Var C,G:string;
          Begin
               Str(HowManyGamersShips,G);
               Str(HowManyComputersShips,C);
               SetTextStyle(4,0,4);
               SetColor(0);
               OutTextXY((GetMaxX div 2)-60,(GetMaxX Div 2)+50,'');
               OutTextXY((GetMaxX div 2)+25,(GetMaxX Div 2)+50,'');
               SetColor(9);
               OutTextXY((GetMaxX div 2)-60,(GetMaxX Div 2)+50,G);
               OutTextXY((GetMaxX div 2)+25,(GetMaxX Div 2)+50,C);
               OutTextXY(GetMaxX Div 2,(GetMaxX div 2)+50,':');
               SetTextStyle(0,0,0);
          end;

Procedure ComputerGame;
          Var x:CrdX;
              y:CrdY;
              i,r:integer;
              Comp:boolean;
          Function SosedKill(x:CrdX;y:CrdY):boolean;
                   var p:boolean;
                   begin
                        p:=false;
                        if x>'a' then begin
                           if GamerMap[pred(x),y].damage=kill then
                              p:=true;
                        end;
                        if x<MaxX then begin
                           if GamerMap[Succ(x),y].damage=kill then
                              p:=true;
                        end;
                        if y>1 then begin
                           if GamerMap[x,pred(y)].damage=kill then
                              p:=true;
                        end;
                        if y<MaxY then begin
                           if GamerMap[x,succ(y)].damage=kill then
                              p:=true;
                        end;

                        SosedKill:=p;
          end;


          Procedure Sosed (X2:CrdX; Y2:CrdY);
                Var Mogno:boolean;
                    KolCicle:integer;
                Begin
                     Randomize;
                     x:=pred('a');
                     y:=0;
                     Mogno:=true;
                     KolCicle:=0;
                     if (not (x2 in ['a'..MaxX])) or (not(y2 in [1..MaxY])) then
                        Exit;
                     Randomize;
                     While (Mogno) and (KolCicle<200) do begin
                           Inc(KolCicle);
                           Case Random(6) of
                                 1: if x2>'a' then begin
                                       if (not GamerMap[pred(x2),y2].Crash) and (not SosedKill(pred(x2),y2)) then begin
                                          x:=pred(x2);
                                          y:=y2;
                                          Mogno:=false;
                                       end;
                                 end;
                                 2: If x2<MaxX then begin
                                       if (not GamerMap[succ(x2),y2].Crash) and (not SosedKill(succ(x2),y2)) then begin
                                          x:= Succ(x2);
                                          y:= y2;
                                          Mogno:=false;
                                       end;
                                 end;
                                 3: If y2>1 then begin
                                       If (not GamerMap[x2,Pred(y2)].Crash) and (not SosedKill(x2,pred(y2))) then begin
                                          x:=x2;
                                          y:=pred(y2);
                                          Mogno:=false;
                                       end;
                                 end;
                                 4: If y2<MaxY then begin
                                       If (not GamerMap[x2,Succ(y2)].Crash) and (not SosedKill(x2,succ(y2))) then begin
                                          x:=x2;
                                          y:=Succ(y2);
                                          Mogno:=false;
                                       end;
                                 end;
                           end;
                     end;
                end;
          Begin
              if exit1 then exit;
              Comp:=true;
              While Comp do begin
                InterfaceGame(False,False,False,True,True);
                if (Ranen.x=pred('a')) or (Ranen.y=0) then
                   Repeat RNDComputer(x,y);
                          if HowManyGamersShips = 0 then Begin
                             Conqueror:=Computer;
                             Exit1:=True;
                          end;
                          if HowManyComputersShips = 0 then Begin
                               Conqueror:=Gamer;
                               Exit1:=True;
                          end;
                          if KeyPressed then
                             If ReadKey=#27 then exit1:=true;
                          if exit1 then exit;
                   Until (not GamerMap[x,y].Crash) and (not SosedKill(x,y))
                else begin
                     Sosed(Ranen.x,Ranen.y);
                     If (x=pred('a')) or (y=0) then
                        Sosed(PRanen.x,PRanen.y);
                        If (x=pred('a')) or (y=0) then
                           Sosed(PPRanen.x,PPRanen.y);
                end;
                SetColor(15);
                Line(50+(ord(x)-ord('a'))*27,23+y*27,77+(ord(x)-ord('a'))*27,50+y*27);
                Line(50+(ord(x)-ord('a'))*27,50+y*27,77+(ord(x)-ord('a'))*27,23+y*27);
                Delay(1000);

                With GamerMap[x,y] do begin
                     Crash:=true;
                     If Ship then begin
                        Comp:=true;
                        Case TypeShip of
                             1:
                             begin
                                Damage:=Kill;
                                Inc(ShipForGamer[1]);
                                Ranen.x:=pred('a');
                                Ranen.y:=0;
                             end;
                             2..4:
                             begin
                                   r:=0;
                                   for i:= 1 to TypeShip do begin
                                       if GamerMap[Coordinate[i].KorX,
                                          Coordinate[i].KorY].Damage=Wounded then begin
                                          inc(r);
                                       end;
                                   end;
                                   if r=TypeShip-1 then begin
                                      For i:= 1 to TypeShip do GamerMap[Coordinate[i].KorX,Coordinate[i].KorY].
                                      Damage:=Kill;
                                      Inc(ShipForGamer[TypeShip]);
                                      Ranen.x:=pred('a');
                                      Ranen.y:=0;
                                      PRanen.x:=Ranen.x;
                                      PRanen.y:=Ranen.y;
                                      PPRanen.x:=Ranen.x;
                                      PPRanen.y:=Ranen.y;
                                   end
                                   else begin
                                        Damage:=Wounded;
                                        PPRanen.x:=PRanen.x;
                                        PPRanen.y:=PRanen.y;
                                        PRanen.x:=Ranen.x;
                                        PRanen.y:=Ranen.y;
                                        Ranen.x:=x;
                                        Ranen.y:=y;
                                   end;

                             end;
                        end;
                     end
                     else Comp:=false;
                end;
                Schet;
              end;
              if HowManyComputersShips = 0 then Begin
                 Conqueror:=Gamer;
                 Exit1:=True;
              end;
              if HowManyGamersShips = 0 then Begin
                 Conqueror:=Computer;
                 Exit1:=True;
              end;
          end;
Procedure GamerGame;
          Var x:CrdX;
              y:CrdY;
              Game:boolean;
              i,n:integer;
          Procedure RND(Var x:CrdX; var y:CrdY);
                    Var x2,y2,Stat,Count:integer;
                    Begin
                         InterfaceGame(False,False,False,True,True);
                         ShowMouse;
                         Repeat MouseButtPressed(0,Stat,Count,x2,y2);
                                If KeyPressed then
                                   if ReadKey=#27 then begin
                                      Exit1:=True;
                                      Exit;
                                   end;
                         Until (Stat=1) and
                               (MouseIn(320,50,590,320));
                         x:=chr( ((x2-270) div 27)+95);
                         y:=(y2 div 27)-1;
                         HideMouse;
                    end;
          Begin
               if exit1 then exit;
               Game:=true;
               While Game do begin
                     Repeat RND(x,y);
                            if HowManyComputersShips = 0 then Begin
                               Conqueror:=Gamer;
                               Exit1:=True;
                            end;
                            if HowManyGamersShips = 0 then Begin
                               Conqueror:=Computer;
                               Exit1:=True;
                            end;
                            If Exit1 then exit;
                     Until not ComputerMap[x,y].Crash;
                     With ComputerMap[x,y] do begin
                          Crash:=true;
                          Game:=false;
                          n:=0;
                          if Ship then begin
                             Game:=true;
                             Damage:=Wounded;
                             For i:= 1 to TypeShip do begin
                                 if ComputerMap[Coordinate[i].KorX,Coordinate[i].KorY].Damage=Wounded then inc(n);
                             end;
                             if n=TypeShip then begin
                                Damage:=Kill;
                                For i:= 1 to TypeShip do begin
                                    ComputerMap[Coordinate[i].KorX,Coordinate[i].KorY].
                                    Damage:=Kill;
                                end;
                                Inc(ShipForComputer[TypeShip]);
                             end;
                          end;
                     end;
                     Schet;
               end;
              if HowManyComputersShips = 0 then Begin
                 Conqueror:=Gamer;
                 Exit1:=True;
              end;
              if HowManyGamersShips = 0 then Begin
                 Conqueror:=Computer;
                 Exit1:=True;
              end;
          End;
Begin
     Gd:=detect;
     InitGraph(Gd,Gm,'e:\Work\Pascal\bgi');
     ClearDevice;
     Conqueror:= UnKnown; Exit1:=False;
     InterfaceGame(True,True,False,False,False);
     OutTextXY(200,(GetMaxY div 2) + 192,'  ᢮ !');
     ZapolnMap(ComputerMap,RNDComputer,ShipForComputer);
     ClearDevice;
     OutTextXY(250,(GetMaxY div 2) + 192,' ᢮ !');
     InterfaceGame(True,True,True,False,False);
     ZapolnMap(GamerMap,RNDGamer,ShipForGamer);
     ClearDevice;
     InterfaceGame(True,True,True,True,True);
     Ranen.x:=pred('a');
     Ranen.y:=0;
     PRanen.x:=pred('a');
     PRanen.y:=0;
     PPRanen.x:=pred('a');
     PPRanen.y:=0;
     While not exit1 do begin
           ComputerGame;
           InterfaceGame(False,False,False,True,True);
           Schet;
           if HowManyGamersShips = 0 then
              Begin
                   Conqueror:=Computer;
                   Exit1:=True;
              end
              else  GamerGame;
           InterfaceGame(False,False,False,True,True);
           Schet;
           If HowManyComputersShips = 0 then
              Begin
                   Conqueror:=Gamer;
                   Exit1:=True;
              end;
     end;
     CloseGraph;
     If Conqueror=UnKnown then WriteLn('  ࠫ  .');
     If Conqueror=Gamer then WriteLn('ࠢ    ஬!');
     If Conqueror=Computer then WriteLn('ࠣ   ᪠!');
     WriteLn('ᨡ,  ᬮ५  !');
     WriteLn('                  ઠ ᠭ.');
     Delay(3000);
end.
